JUCE: AudioParameterFloat Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Protected Member Functions | List of all members
AudioParameterFloat Class Reference
juce_audio_processors » utilities

A subclass of AudioProcessorParameter that provides an easy way to create a parameter which maps onto a given NormalisableRange. More...

`#include <juce_AudioParameterFloat.h>`

Inheritance diagram for AudioParameterFloat:

## Public Member Functions
| AudioParameterFloat (const ParameterID &parameterID, const String &parameterName, NormalisableRange< float > normalisableRange, float defaultValue, const AudioParameterFloatAttributes &attributes={})
| Creates a AudioParameterFloat with the specified parameters.
| AudioParameterFloat (const ParameterID &parameterID, const String &parameterName, NormalisableRange< float > normalisableRange, float defaultValue, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter, std::function< String(float value, int maximumStringLength)> stringFromValue=nullptr, std::function< float(const String &text)> valueFromString=nullptr)
| Creates a AudioParameterFloat with the specified parameters.
| AudioParameterFloat (const ParameterID &parameterID, const String &parameterName, float minValue, float maxValue, float defaultValue)
| Creates a AudioParameterFloat with an ID, name, and range.
| ~AudioParameterFloat () override
| Destructor.
float | get () const noexcept
| Returns the parameter's current value.
| operator float () const noexcept
| Returns the parameter's current value.
AudioParameterFloat & | operator= (float newValue)
| Changes the parameter's current value.
const NormalisableRange< float > & | getNormalisableRange () const override
| Returns the range of values that the parameter can take.
Public Member Functions inherited from RangedAudioParameter
int | getNumSteps () const override
| Returns the number of steps for this parameter based on the normalisable range's interval.
float | convertTo0to1 (float v) const noexcept
| Normalises and snaps a value based on the normalisable range.
float | convertFrom0to1 (float v) const noexcept
| Denormalises and snaps a value based on the normalisable range.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
Public Member Functions inherited from AudioProcessorParameterWithID
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
String | getName (int) const override
| Returns the name to display for this parameter, which should be made to fit within the given string length.
String | getLabel () const override
| Some parameters may be able to return a label string for their units.
Category | getCategory () const override
| Returns the parameter's category.
String | getParameterID () const override
| Returns an ID that is unique to this parameter.
bool | isMetaParameter () const override
| Should return true if this parameter is a "meta" parameter.
bool | isAutomatable () const override
| Returns true if the host can automate this parameter.
bool | isOrientationInverted () const override
| This can be overridden to tell the host that this parameter operates in the reverse direction.
Public Member Functions inherited from HostedAudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
Public Member Functions inherited from AudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
virtual | ~AudioProcessorParameter ()
| Destructor.
void | setValueNotifyingHost (float newValue)
| A processor should call this when it needs to change one of its parameters.
void | beginChangeGesture ()
| Sends a signal to the host to tell it that the user is about to start changing this parameter.
void | endChangeGesture ()
| Tells the host that the user has finished changing this parameter.
virtual bool | isDiscrete () const
| Returns whether the parameter uses discrete values, based on the result of getNumSteps, or allows the host to select values continuously.
virtual bool | isBoolean () const
| Returns whether the parameter represents a boolean switch, typically with "On" and "Off" states.
int | getParameterIndex () const noexcept
| Returns the index of this parameter in its parent processor's parameter list.
virtual String | getCurrentValueAsText () const
| Returns the current value of the parameter as a String.
virtual StringArray | getAllValueStrings () const
| Returns the set of strings which represent the possible states a parameter can be in.
int | getVersionHint () const
void | addListener (Listener *newListener)
| Registers a listener to receive events when the parameter's state changes.
void | removeListener (Listener *listener)
| Removes a previously registered parameter listener.
void | sendValueChangedMessageToListeners (float newValue)

## Public Attributes
NormalisableRange< float > | range
| Provides access to the parameter's range.
Public Attributes inherited from AudioProcessorParameterWithID
const String | paramID
| Provides access to the parameter's ID string.
const String | name
| Provides access to the parameter's name.
const String | label
| Provides access to the parameter's label.
const Category | category
| Provides access to the parameter's category.

## Protected Member Functions
virtual void | valueChanged (float newValue)
| Override this method if you are interested in receiving callbacks when the parameter value changes.

## Additional Inherited Members
Public Types inherited from AudioProcessorParameter
enum | Category { genericParameter = (0 << 16) | 0 , inputGain = (1 << 16) | 0 , outputGain = (1 << 16) | 1 , inputMeter = (2 << 16) | 0 , outputMeter = (2 << 16) | 1 , compressorLimiterGainReductionMeter = (2 << 16) | 2 , expanderGateGainReductionMeter = (2 << 16) | 3 , analysisMeter = (2 << 16) | 4 , otherMeter = (2 << 16) | 5 }

## Detailed Description

A subclass of AudioProcessorParameter that provides an easy way to create a parameter which maps onto a given NormalisableRange.

See also
  AudioParameterInt, AudioParameterBool, AudioParameterChoice

## Constructor & Destructor Documentation

## ◆ AudioParameterFloat() [1/3]

AudioParameterFloat::AudioParameterFloat | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | NormalisableRange< float > | normalisableRange,
|  | float | defaultValue,
|  | const AudioParameterFloatAttributes & | attributes = {} )

Creates a AudioParameterFloat with the specified parameters.

Note that the attributes argument is optional and only needs to be supplied if you want to change options from their default values.

Example usage:

auto attributes = AudioParameterFloatAttributes().withStringFromValueFunction ([] (auto x, auto) { return String (x * 100); })
.withLabel ("%");
auto param = std::make_unique<AudioParameterFloat> ("paramID", "Parameter Name", NormalisableRange<float>(), 0.5f, attributes);
AudioParameterFloatAttributes
Properties of an AudioParameterFloat.
Definition juce_AudioParameterFloat.h:36
NormalisableRange
Represents a mapping between an arbitrary range of values and a normalised 0->1 range.
Definition juce_NormalisableRange.h:41
RangedAudioParameterAttributes::withStringFromValueFunction
auto withStringFromValueFunction(StringFromValue x) const
An optional lambda function that converts a non-normalised value to a string with a maximum length.
Definition juce_RangedAudioParameter.h:55
String
The JUCE String class!
Definition juce_String.h:54
x
float x
Definition juce_UnityPluginInterface.h:192

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  normalisableRange | The NormalisableRange to use
  defaultValue | The non-normalised default value
  attributes | Optional characteristics

## ◆ AudioParameterFloat() [2/3]

AudioParameterFloat::AudioParameterFloat | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | NormalisableRange< float > | normalisableRange,
|  | float | defaultValue,
|  | const String & | parameterLabel,
|  | Category | parameterCategory = AudioProcessorParameter::genericParameter,
|  | std::function< String(float value, int maximumStringLength)> | stringFromValue = nullptr,
|  | std::function< float(const String &text)> | valueFromString = nullptr )

Creates a AudioParameterFloat with the specified parameters.

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  normalisableRange | The NormalisableRange to use
  defaultValue | The non-normalised default value
  parameterLabel | An optional label for the parameter's value
  parameterCategory | An optional parameter category
  stringFromValue | An optional lambda function that converts a non-normalised value to a string with a maximum length. This may be used by hosts to display the parameter's value.
  valueFromString | An optional lambda function that parses a string and converts it into a non-normalised value. Some hosts use this to allow users to type in parameter values.

## ◆ AudioParameterFloat() [3/3]

AudioParameterFloat::AudioParameterFloat | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | float | minValue,
|  | float | maxValue,
|  | float | defaultValue )

Creates a AudioParameterFloat with an ID, name, and range.

On creation, its value is set to the default value. For control over skew factors, you can use the other constructor and provide a NormalisableRange.

## ◆ ~AudioParameterFloat()

AudioParameterFloat::~AudioParameterFloat | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ get()

float AudioParameterFloat::get | ( |  | ) | const
| noexcept

Returns the parameter's current value.

## ◆ operator float()

AudioParameterFloat::operator float | ( |  | ) | const
| noexcept

Returns the parameter's current value.

## ◆ operator=()

AudioParameterFloat & AudioParameterFloat::operator= | ( | float | newValue | ) |

Changes the parameter's current value.

## ◆ getNormalisableRange()

const NormalisableRange< float > & AudioParameterFloat::getNormalisableRange | ( |  | ) | const
| overridevirtual

Returns the range of values that the parameter can take.

Implements RangedAudioParameter.

## ◆ valueChanged()

virtual void AudioParameterFloat::valueChanged | ( | float | newValue | ) |
| protectedvirtual

Override this method if you are interested in receiving callbacks when the parameter value changes.

## Member Data Documentation

## ◆ range

NormalisableRange<float> AudioParameterFloat::range

Provides access to the parameter's range.

The documentation for this class was generated from the following file:

- juce_AudioParameterFloat.h